/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.mappers.TubeGlyphs;

import org.visnow.jscic.Field;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.geometries.parameters.DataMappingParams;
import org.visnow.vn.geometries.parameters.RenderingParams;
import org.visnow.vn.engine.core.Parameters;
import static org.visnow.vn.lib.basic.mappers.TubeGlyphs.TubeGlyphsShared.*;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class GUI extends javax.swing.JPanel
{
    private Field inField = null;
    private float smax = 1;
    private Parameters parameters;

    /**
     * Creates new form VNgraph3DUI
     */
    public GUI()
    {
        initComponents();
        mapComboBox.setAddNullComponent(true);
        mapComboBox.setTitle("Tube radius");
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        mapComboBox = new org.visnow.vn.lib.gui.DataComponentSelector();
        scaleSlider = new org.visnow.vn.gui.widgets.ExtendedSlider();
        lodSlider = new javax.swing.JSlider();
        bgrBox = new javax.swing.JCheckBox();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));
        colorPanel = new org.visnow.vn.geometries.gui.ColorMappedComponentPanel();

        setLayout(new java.awt.BorderLayout());

        jTabbedPane1.setTabLayoutPolicy(javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);

        jPanel1.setFont(new java.awt.Font("Dialog", 0, 10)); // NOI18N
        jPanel1.setLayout(new java.awt.GridBagLayout());

        mapComboBox.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                mapComboBoxStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(mapComboBox, gridBagConstraints);

        scaleSlider.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.FLOAT);
        scaleSlider.setMax(100);
        scaleSlider.setMin(0.1);
        scaleSlider.setScaleType(org.visnow.vn.gui.widgets.ExtendedSlider.ScaleType.LOGARITHMIC);
        scaleSlider.setValue(2);
        scaleSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("Tube scale"));
        scaleSlider.setMinimumSize(new java.awt.Dimension(65, 60));
        scaleSlider.setPreferredSize(new java.awt.Dimension(200, 60));
        scaleSlider.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                scaleSliderUserChangeAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel1.add(scaleSlider, gridBagConstraints);

        lodSlider.setFont(new java.awt.Font("Dialog", 0, 10)); // NOI18N
        lodSlider.setMajorTickSpacing(5);
        lodSlider.setMaximum(50);
        lodSlider.setMinimum(5);
        lodSlider.setMinorTickSpacing(1);
        lodSlider.setSnapToTicks(true);
        lodSlider.setValue(10);
        lodSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("Tube smoothness"));
        lodSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                lodSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel1.add(lodSlider, gridBagConstraints);

        bgrBox.setText("Background ");
        bgrBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                bgrBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
        jPanel1.add(bgrBox, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.weighty = 1.0;
        jPanel1.add(filler1, gridBagConstraints);

        jTabbedPane1.addTab("Tubes", jPanel1);
        jTabbedPane1.addTab("Datamap", colorPanel);

        add(jTabbedPane1, java.awt.BorderLayout.PAGE_START);
    }// </editor-fold>//GEN-END:initComponents

    private void scaleSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_scaleSliderStateChanged

    }//GEN-LAST:event_scaleSliderStateChanged

    private void bgrBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_bgrBoxActionPerformed
    {//GEN-HEADEREND:event_bgrBoxActionPerformed
        parameters.set(BACKGROUND, bgrBox.isSelected());
    }//GEN-LAST:event_bgrBoxActionPerformed

    private void lodSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_lodSliderStateChanged
    {//GEN-HEADEREND:event_lodSliderStateChanged
        if (!lodSlider.getValueIsAdjusting())
            parameters.set(LEVEL_OF_DETAILS, lodSlider.getValue());
    }//GEN-LAST:event_lodSliderStateChanged

    private void scaleSliderUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_scaleSliderUserChangeAction
    {//GEN-HEADEREND:event_scaleSliderUserChangeAction
        parameters.set(SCALE, (Float) scaleSlider.getValue());
    }//GEN-LAST:event_scaleSliderUserChangeAction

    private void mapComboBoxStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_mapComboBoxStateChanged
    {//GEN-HEADEREND:event_mapComboBoxStateChanged
        parameters.set(SELECTED_COMPONENT, mapComboBox.getComponent());
    }//GEN-LAST:event_mapComboBoxStateChanged

    private void setScaleMinMax(ParameterProxy p)
    {
        scaleSlider.setMax(p.get(META_SCALE_MAX));
        scaleSlider.setMin(p.get(META_SCALE_MAX) / 100);
        scaleSlider.setValue(p.get(SCALE));//smax / 10);
    }

    public void setParams(Parameters params, DataMappingParams mapParams, RenderingParams renderParams)
    {
        colorPanel.setParams(mapParams);
        this.parameters = params;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox bgrBox;
    private org.visnow.vn.geometries.gui.ColorMappedComponentPanel colorPanel;
    private javax.swing.Box.Filler filler1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JSlider lodSlider;
    private org.visnow.vn.lib.gui.DataComponentSelector mapComboBox;
    private org.visnow.vn.gui.widgets.ExtendedSlider scaleSlider;
    // End of variables declaration//GEN-END:variables

    void setParameters(Parameters parameters, DataMappingParams mapParams, RenderingParams renderParams)
    {
        colorPanel.setParams(mapParams);
        this.parameters = parameters;
    }

    void updateGUI(ParameterProxy p, boolean resetFully, boolean resetScale)
    {
        if (resetFully) {
            mapComboBox.setDataSchema(p.get(META_SCHEMA));
            colorPanel.setData(p.get(META_SCHEMA));
            setScaleMinMax(p);
            lodSlider.setValue(p.get(LEVEL_OF_DETAILS));
            bgrBox.setSelected(p.get(BACKGROUND));
            if (mapComboBox.getnItems() > p.get(SELECTED_COMPONENT)) {
                mapComboBox.setSelectedIndex(p.get(SELECTED_COMPONENT));
            }
        }
        if (resetScale)
            setScaleMinMax(p);
//        bgrBox.setEnabled(p.get(META_BGR_ENABLED));

    }
}
